import es
import random, gamethread, playerlib, popuplib, cfglib, usermsg

config = cfglib.AddonCFG(es.getAddonPath('bdm') + '/bdm.cfg')

config.text('******************************************')
config.text(" BDM (BackRaw's DeathMatch) Configuration ")
config.text('******************************************')
config.text('\n')
config.text('***************')
config.text(' -> Adverts <- ')
config.text('***************')
adverts = config.cvar('bdm_adverts', 1, 'Enable/disable Adverts')
advert = config.cvar('bdm_advert', '#green[#lightgreenBDM#green] #defaultis loaded.', 'Colors: #default - Yellow, #green - Dark Green, #lightgreen - Lighter Green')
honly_advert = config.cvar('bdm_headshot_only_advert', '#green[#lightgreenBDM#green] #lightgreenHeadshot Only #defaultis activated. Only shoot the head!', 'Advert for Headshot Only (if enabled below)')
config.text('\n')
config.text('*********************')
config.text(' -> FF On? Noisy? <- ')
config.text('*********************')
bdm_ff = config.cvar('bdm_ff', 0, 'On = 1, Off = 0')
bdm_noisy = config.cvar('bdm_noisy', 0, 'Does another script use eventscripts_noisy? (Yes = 1, No = 0)')
config.text('\n')
config.text('*******************')
config.text(' -> BOT-WEAPONS <- ')
config.text('*******************')
bdm_bot_weapons = config.cvar('bdm_bot_weapons', 1, 'Give Bots weapons?')
config.text('\n')
config.text('************************************************')
config.text(' -> RESPAWN - SPAWN-PROTECTION - SPAWNPOINTS <- ')
config.text('************************************************')
bdm_respawn = config.cvar('bdm_respawn', .75, 'How long should a respawn take?')
bdm_spawnprotection = config.cvar('bdm_spawnprotection', 1, 'Enable/disable spawn-protection')
bdm_spawnprotectiontime = config.cvar('bdm_spawnprotectiontime', 2, 'How long should the spawn-protection take?')
bdm_spawnprotectioncolor_t = config.cvar('bdm_spawnprotectioncolor_t', '255, 0, 0, 105', 'Set the protection-color for Terrorists')
bdm_spawnprotectioncolor_ct = config.cvar('bdm_spawnprotectioncolor_ct', '0, 0, 255, 105', 'Set the protection-color for Counter-Terrorists')
bdm_spawnpoints = config.cvar('bdm_spawnpoints', 1, 'Use spawnpoints?')
config.text('\n')
config.text('********************************')
config.text(' -> REFILL AMMO? ENABLE AWP? <- ')
config.text('********************************')
bdm_refillammo = config.cvar('bdm_refillammo', 1, 'Should ammo be refilled? (requires eventscripts_noisy to be set to 1, like bdm_noisy 0 does)')
bdm_awp = config.cvar('bdm_awp', 0, 'Should AWP be available to use?')
config.text('\n')
config.text('*******************')
config.text(' -> Show-Damage <- ')
config.text('*******************')
bdm_sd = config.cvar('bdm_sd', 1, 'Enable/disable Show-Damage')
config.text('\n')
config.text('******************')
config.text(' -> Game Modes <- ')
config.text('******************')
honly = config.cvar('bdm_headshot_only', 1, 'Headshot Only - Players can only kill if they hit the head!')
config.text('\n')
config.text('**********************************************')
config.text(" BDM (BackRaw's Deathmatch) Configuration End ")
config.text('**********************************************')

config.write()

random_sec = ['glock', 'usp', 'deagle', 'fiveseven', 'elite', 'p228']
random_prim = ['m4a1', 'ak47', 'galil', 'famas', 'sg552', 'aug', 'scout', 'm3', 'xm1014', 'tmp', 'mac10', 'mp5navy', 'ump45', 'p90', 'm249']
bdm_menu = 0
bdm_prim_menu = 0
bdm_sec_menu = 0
players = {}
spawns = []

def load():
    global bdm_menu, bdm_prim_menu, bdm_sec_menu
    config.execute()
    es.ServerVar("BackRaw's Deathmatch", '1.7', 'ESP').makepublic()
    if bdm_noisy == 0:
        es.doblock('corelib/noisy_on')
    if bdm_ff == 1:
        es.server.cmd('mp_friendlyfire 1')
    else:
        es.server.cmd('mp_friendlyfire 0')
    bdm_menu = popuplib.easymenu('bdm_weps', '_popup_choice', menu)
    bdm_menu.settitle('Weapon-Menu')
    bdm_menu.addoption('newweps', 'New Equipment')
    bdm_menu.addoption('again', 'Show this menu again each spawn')
    bdm_menu.addoption('never', "Don't show this menu again each spawn")
    bdm_menu.addoption('random', 'Random Weapons')
    bdm_sec_menu = popuplib.easymenu('bdm_sec', '_popup_choice', chosen_sec)
    bdm_sec_menu.settitle('Choose a secondary weapon')
    bdm_sec_menu.addoption(0, 'No Secondary')
    bdm_sec_menu.addoption('usp', 'USP')
    bdm_sec_menu.addoption('glock', 'Glock 18C')
    bdm_sec_menu.addoption('deagle', 'Desert Eagle')
    bdm_sec_menu.addoption('p228', 'P228')
    bdm_sec_menu.addoption('fiveseven', 'ES Five-Seven')
    bdm_sec_menu.addoption('elite', 'Dual .40 Berettas')
    bdm_prim_menu = popuplib.easymenu('bdm_prim', '_popup_choice', chosen_prim)
    bdm_prim_menu.settitle('Choose a primary weapon')
    bdm_prim_menu.addoption(0, 'No Primary')
    bdm_prim_menu.addoption('m4a1', 'Maverick M4A1 Carbine')
    bdm_prim_menu.addoption('ak47', 'Avtomat Kalashnikova - 47')
    bdm_prim_menu.addoption('galil', 'IMI Galil')
    bdm_prim_menu.addoption('famas', 'FAMAS')
    bdm_prim_menu.addoption('sg552', 'SG-552 Commando')
    bdm_prim_menu.addoption('aug', 'Steyr AUG')
    bdm_prim_menu.addoption('scout', 'Steyr Scout')
    if bdm_awp:
        bdm_prim_menu.addoption('awp', 'Artic Warfare Police (AWP)')
    bdm_prim_menu.addoption('m3', 'M3 Super 90 Entry')
    bdm_prim_menu.addoption('xm1014', 'XM1014 (M4 Super 90)')
    bdm_prim_menu.addoption('tmp', 'Tactical Mashine Pistol (TMP)')
    bdm_prim_menu.addoption('mac10', 'Ingram MAC-10')
    bdm_prim_menu.addoption('mp5navy', 'MP5-Navy')
    bdm_prim_menu.addoption('ump45', 'Universal Mashine Pistol (UMP 45)')
    bdm_prim_menu.addoption('p90', 'P90')
    bdm_prim_menu.addoption('m249', 'M249 Para')
    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'bdm/guns')
    for player in playerlib.getUseridList('#human'):
        user = playerlib.uniqueid(player, True)
        if not user in players:
            default(user)
    for userid in es.getUseridList():
        es.server.cmd('es_xfire %s func_buyzone Disable;es_xfire %s func_bomb_target Disable;es_xfire %s func_hostage_rescue Disable' % (userid, userid, userid))

def unload():
    bdm_menu.delete()
    bdm_sec_menu.delete()
    bdm_prim_menu.delete()
    players.clear()
    es.unregsaycmd('guns')
    for userid in es.getUseridList():
        es.server.cmd('es_xfire %s func_buyzone Enable;es_xfire %s func_bomb_target Enable;es_xfire %s func_hostage_rescue Enable' % (userid, userid, userid))

def default(user):
    players[user] = {}
    players[user]['sec'] = 0
    players[user]['prim'] = 0
    players[user]['random'] = 0
    players[user]['never'] = 0
    players[user]['display'] = 0

def player_activate(ev):
    userid = ev['userid']
    user = playerlib.uniqueid(userid, True)
    if not user in players:
        default(user)

def guns():
    userid = es.getcmduserid()
    bdm_menu.send(userid)

def menu(userid, choice, popupid):
    user = playerlib.uniqueid(userid, True)
    sec = players[user]['sec']
    prim = players[user]['prim']
    if choice == 'newweps':
        default(user)
        bdm_sec_menu.send(userid)
    else:
        strip_player(userid)
    if choice == 'again':
        if sec or prim:
            players[user]['never'] = 0
            players[user]['display'] = 1
            players[user]['random'] = 0
            if sec:
                gamethread.delayed(0, givesec, (userid, sec))
            if prim:
                gamethread.delayed(0, giveprim, (userid, prim))
        else:
            bdm_menu.send(userid)
    elif choice == 'never':
        if sec or prim:
            players[user]['never'] = 1
            players[user]['display'] = 0
            players[user]['random'] = 0
            if sec:
                gamethread.delayed(0, givesec, (userid, sec))
            if prim:
                gamethread.delayed(0, giveprim, (userid, prim))
        else:
            bdm_menu.send(userid)
    elif choice == 'random':
        players[user]['never'] = 0
        players[user]['display'] = 0
        players[user]['random'] = 1
        gamethread.delayed(0, randomweps, (userid))

def chosen_sec(userid, choice, popupid):
    user = playerlib.uniqueid(userid, True)
    players[user]['sec'] = choice
    sec = players[user]['sec']
    strip_player(userid)
    bdm_prim_menu.send(userid)
    gamethread.delayed(0, givesec, (userid, sec))

def chosen_prim(userid, choice, popupid):
    user = playerlib.uniqueid(userid, True)
    players[user]['prim'] = choice
    prim = players[user]['prim']
    gamethread.delayed(0, giveprim, (userid, prim))

def strip_player(userid):
    es.server.cmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.cmd('es_xgive %s player_weaponstrip' % userid)
    es.server.cmd('es_xfire %s player_weaponstrip strip' % userid)
    es.server.queuecmd('es_xgive %s weapon_knife;es_xgive %s item_assaultsuit' % (userid, userid))

def randomweps(userid):
    if bdm_awp == 1:
        if not 'awp' in random_prim:
            random_prim.append('awp')
    else:
        if 'awp' in random_prim:
            random_prim.remove('awp')
    es.server.queuecmd('es_xgive %s weapon_%s' % (userid, random.choice(random_sec)))
    es.sexec(userid, 'use slot2')
    es.server.queuecmd('es_xgive %s weapon_%s' % (userid, random.choice(random_prim)))
    es.server.queuecmd('es_xgive %s weapon_hegrenade' % userid)
    gamethread.delayed(0, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', 100))

def givesec(userid, sec):
    es.server.queuecmd('es_xgive %s weapon_%s' % (userid, sec))
    es.sexec(userid, 'use slot2')
    es.server.queuecmd('es_xgive %s weapon_hegrenade' % userid)
    gamethread.delayed(0, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', 100))

def giveprim(userid, prim):
    es.server.queuecmd('es_xgive %s weapon_%s' % (userid, prim))
    es.server.queuecmd('es_xgive %s weapon_hegrenade' % userid)
    gamethread.delayed(0, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', 100))

def round_start(ev):
    if bdm_ff == 1:
        es.server.cmd('mp_friendlyfire 1')
    else:
        es.server.cmd('mp_friendlyfire 0')
    if adverts:
        if advert:
            es.msg('#multi', advert)
        if honly_advert:
            es.msg('#multi', honly_advert)

def round_freeze_end(ev):
    for userid in playerlib.getUseridList('#dead'):
        es.server.cmd('est_Spawn %s' % userid)

def player_spawn(ev):
    userid = ev['userid']
    user = playerlib.uniqueid(userid, True)
    player = playerlib.getPlayer(userid)
    es.server.cmd('es_xfire %s func_buyzone Disable' % userid)
    es.server.cmd('es_xfire %s func_bomb_target Disable' % userid)
    es.server.cmd('es_xfire %s func_hostage_rescue Disable' % userid)
    strip_player(userid)
    if ev['es_steamid'] == 'BOT':
        if bdm_bot_weapons:
            gamethread.delayed(0, randomweps, (userid))
    else:
        sec = players[user]['sec']
        prim = players[user]['prim']
        if sec or prim or players[user]['random']:
            if bdm_spawnpoints:
                x, y, z = random.choice(spawns)
                es.server.cmd('es_xsetpos %s %s %s %s' % (userid, x, y, z))
            if players[user]['random']:
                gamethread.delayed(0, randomweps, (userid))
            elif players[user]['never']:
                if sec:
                    gamethread.delayed(0, givesec, (userid, sec))
                if prim:
                    gamethread.delayed(0, giveprim, (userid, prim))
            elif players[user]['display']:
                if sec:
                    gamethread.delayed(0, givesec, (userid, sec))
                if prim:
                    gamethread.delayed(0, giveprim, (userid, prim))
                bdm_menu.send(userid)
            else:
                players[user]['random'] = 0
                players[user]['never'] = 0
                players[user]['display'] = 0
                bdm_menu.send(userid)
        else:
            default(user)
            bdm_menu.send(userid)
    if bdm_spawnprotection:
        es.server.cmd('est_God %s 1' % userid)
        if int(ev['es_userteam']) == 2:
            player.set('color', str((bdm_spawnprotectioncolor_t)).split(','))
        else:
            player.set('color', str((bdm_spawnprotectioncolor_ct)).split(','))
        es.delayed(bdm_spawnprotectiontime, 'est_God %s 0' % userid)
        gamethread.delayed(bdm_spawnprotectiontime, player.set, ('color', (255, 255, 255, 255)))

def player_hurt(ev):
    userid = ev['userid']
    attacker = ev['attacker']
    dmg = ev['dmg_health']
    if honly and ev['hitgroup'] != '1':
        if not ev['weapon'] in ['hegrenade', 'knife']:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 100)
            es.server.cmd('es_xgive %s item_assaultsuit' % userid)
    if bdm_sd:
        es.centertell(attacker, 'Damage Given: %s' % dmg)
        usermsg.hudhint(userid, 'Damage Taken: %s' % dmg)

def player_death(ev):
    userid = ev['userid']
    if bdm_spawnpoints:
        x, y, z = es.getplayerlocation(userid)
        if not [x, y, z] in spawns:
            spawns.append((x,y, z))
    es.server.cmd('est_RemoveIdle weapon')
    if int(ev['headshot']) or ev['weapon'] in ['hegrenade', 'knife']:
        es.server.queuecmd('es_xgive %s weapon_hegrenade' % ev['attacker'])
    if bdm_respawn:
        es.delayed(bdm_respawn, 'est_Spawn %s' % userid)
        es.delayed(bdm_respawn, 'est_RemoveIdle cs_ragdoll')

def round_end(ev):
    if ev['reason'] in ['16', '10']:
        for players in es.getUseridList():
            bdm_menu.unsend(players)

def weapon_reload(ev):
    userid = ev['userid']
    if bdm_refillammo == 1:
        weaponammo(userid)

def weapon_fire_on_empty(ev):
    userid = ev['userid']
    if bdm_refillammo == 1:
        weaponammo(userid)

def weaponammo(userid):
    user = playerlib.getPlayer(userid)
    player = playerlib.getPlayer(userid)
    if player.get('weapon') == 'weapon_glock':
        user.set('ammo', ['secondary', '120'])
    elif player.get('weapon') == 'weapon_usp':
        user.set('ammo', ['secondary', '100'])
    elif player.get('weapon') == 'weapon_p228':
        user.set('ammo', ['secondary', '52'])
    elif player.get('weapon') == 'weapon_deagle':
        user.set('ammo', ['secondary', '35'])
    elif player.get('weapon') == 'weapon_fiveseven':
        user.set('ammo', ['secondary', '100'])
    elif player.get('weapon') == 'weapon_elite':
        user.set('ammo', ['secondary', '120'])
    elif player.get('weapon') == 'weapon_m4a1':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_ak47':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_galil':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_famas':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_sg552':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_aug':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_scout':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_awp':
        user.set('ammo', ['primary', '30'])
    elif player.get('weapon') == 'weapon_m3':
        user.set('ammo', ['primary', '32'])
    elif player.get('weapon') == 'weapon_xm1014':
        user.set('ammo', ['primary', '32'])
    elif player.get('weapon') == 'weapon_tmp':
        user.set('ammo', ['primary', '120'])
    elif player.get('weapon') == 'weapon_mac10':
        user.set('ammo', ['primary', '100'])
    elif player.get('weapon') == 'weapon_mp5navy':
        user.set('ammo', ['primary', '120'])
    elif player.get('weapon') == 'weapon_ump45':
        user.set('ammo', ['primary', '100'])
    elif player.get('weapon') == 'weapon_p90':
        user.set('ammo', ['primary', '100'])
    elif player.get('weapon') == 'weapon_m249':
        user.set('ammo', ['primary', '200'])
